#ifndef _KMAMELEON_H__
#define _KMAMELEON_H__

//Qt stuff...
#include <qwidget.h>
#include <qtoolbutton.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qtooltip.h>
#include <qcursor.h>
#include <qfileinfo.h>
#include <qstringlist.h>
#include <qtextstream.h>
#include <qfile.h>

//KDE stuff...
#include <kapplication.h>
#include <klocale.h>
#include <khelpmenu.h>
#include <kstandarddirs.h>
#include <kpopupmenu.h>
#include <kprocess.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kdeversion.h>

//custom...
#include "kmmversion.h"
#include "kmmifacedlg.h"
#include "kmmdebug.h"
#include "xmameconfig.h"

//Tools...
#include "toolromchecker.h"
#include "toolpathfinder.h"
#include "toolromlister.h"

class KMameleon : public mainDoor
{
Q_OBJECT
public:
	KMameleon();
	~KMameleon();

	KHelpMenu *helpMenu;
	KConfig *config;
	KPopupMenu *mnuPopup;
	KPopupMenu *toolPopup;

	QString conf_selectedRomPath;
	QString conf_selectedGame;
	QString conf_xmameBinPath;
	QString setLibrary;
	QString fsOptions;

	DevDebug *dbgWindow;
	XMameCfg *newConfig;

//Tools-only definitions...
	ToolRomCheckerPlugin *romChecker;
	ToolPathFinderPlugin *pathFinder;
	ToolRomListerPlugin *romLister;

private:
//have to check for the right versions... KProcess can't use setUseShell(bool)
#if KDE_VERSION >= 306
	KProcess proc;
#else
	KShellProcess proc;
#endif

	QString temp;
	QString outBuff;
	QString options;


private slots:
	void runPlay();
	void goStop();
	void runConf();
	void reloadList();
	void popHelp();
	void popTools();
	void getOutput( KProcess *, char *, int);
	void getErrOutput( KProcess *, char *, int);
	void getStoppedStatus(KProcess *);
	QString modes(int);
	void loadPopups();

//tools...:
	void loadRomChecker();
	void loadPathFinder();
	void loadRomLister();

protected slots:
	void closeEvent (QCloseEvent);
};

#endif
