#include "toolpathfinder.h"

ToolPathFinderPlugin::ToolPathFinderPlugin()
{
//general
	config=kapp->config();

	findMenu= new KPopupMenu(this);
	findMenu->insertItem( i18n("Show default paths"), this, SLOT(slotFindPaths()) );
	findMenu->insertItem( i18n("Show && set default paths"), this, SLOT(slotFindAndSetPaths()) );

//find dropdown...
	btnFind->setPopup(findMenu);

//connections...
	connect(btnClose, SIGNAL(clicked()), this, SLOT(close()) );
	connect(&pProc, SIGNAL( receivedStdout(KProcess *, char *, int)), this, SLOT( getOutput( KProcess *, char *, int)) );
}

ToolPathFinderPlugin::~ToolPathFinderPlugin()
{

}

void ToolPathFinderPlugin::slotFindPaths()
{
	if (slotMameType() !="" )
	{
		QString options=slotMameType();
		options +=" -sc ";
		options +=" | grep -i / ";

		pProc.clearArguments();
		#if KDE_VERSION >= 306
			pProc.setUseShell(true);
		#endif

		pProc << options.local8Bit();
		if (pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput) == false)
		{
			kdDebug() << "something wrong" << endl;
		}
	}
	else
		KMessageBox::information(this,i18n("This XMame type does not exists or it is not configured"));
}

void ToolPathFinderPlugin::getOutput(KProcess *, char *text, int len)
{
	QStringList list;
	QString temp;
	int pos;
	QString dataStream;

	romOutput -> clear();

	temp.fill(' ',len+1);
	temp.replace(0,len,text);
	temp[len]='\0';
	paths=QStringList::split("\n", temp.local8Bit());
	pathList = temp.local8Bit();

	for ( unsigned int i= 0; i<paths.count(); i++)
	{
		if (paths[i].contains("rom") > 0 && paths[i].contains("/") > 0)
		{
			kdDebug() << paths[i] << endl;
			list += paths[i];
		}
		if (paths[i].contains("samples") > 0 && paths[i].contains("/") > 0)
		{
			kdDebug() << paths[i] << endl;
			list += paths[i];
		}
		if (paths[i].contains("artwork") > 0 && paths[i].contains("/") > 0)
		{
			kdDebug() << paths[i] << endl;
			list += paths[i];
		}
	}

	if (setPaths  == true)
	{
		for ( unsigned int i= 0; i<list.count(); i++)
			kdDebug() << paths[i] << endl;

	//this will handle the paths...
		config->setGroup("general");
		for (int pthEnv =0; pthEnv <=2; pthEnv++)
		{
			switch(pthEnv)
			{
				case 0: //rompath
					pos = list[pthEnv].find("/");
					dataStream = list[pthEnv].mid(pos);
					kdDebug() << dataStream << endl;
					if (config->readEntry("xmame_rom","").isEmpty())
						config->writeEntry("xmame_rom",dataStream);
					else
						if (KMessageBox::questionYesNo(this,i18n("This will override Your current rom path settings... Want me to proceed?")) == 3)
							config->writeEntry("xmame_rom",dataStream);
				break;
				case 1: //samplepath
					pos = list[pthEnv].find("/");
					dataStream = list[pthEnv].mid(pos);
					kdDebug() << dataStream << endl;
					if (config->readEntry("xmame_samples","").isEmpty())
						config->writeEntry("xmame_samples",dataStream);
					else
						if (KMessageBox::questionYesNo(this,i18n("This will override Your current sample path settings... Want me to proceed?")) == 3)
							config->writeEntry("xmame_samples",dataStream);
				break;
				case 2: //artworkpath | this can be wrong in xmame > 0.64
					pos = list[pthEnv].find("/");
					dataStream = list[pthEnv].mid(pos);
					kdDebug() << dataStream << endl;
					if (config->readEntry("xmame_art","").isEmpty())
						config->writeEntry("xmame_art",dataStream);
					else
						if (KMessageBox::questionYesNo(this,i18n("This will override Your current artwork path settings... Want me to proceed?")) == 3)
							config->writeEntry("xmame_art",dataStream);
				break;
			} //end switch
		} // end for loop
	} //end if
	romOutput->setText( list.join("\n") );
	list = 0L;
}

void ToolPathFinderPlugin::slotFindAndSetPaths()
{
	if (!slotMameType().isEmpty() )
	{
		setPaths = true;
		QString options=slotMameType();
		options +=" -sc ";
		options +=" | grep -i / ";

		pProc.clearArguments();
		#if KDE_VERSION >= 306
			pProc.setUseShell(true);
		#endif

		pProc << options.local8Bit();
		if (pProc.start(KProcess::NotifyOnExit, KProcess::AllOutput) == false)
		{
			kdDebug() << "something wrong" << endl;
		}
		kdDebug() << options << endl;
	}
	else
		KMessageBox::information(this,i18n("This XMame type does not exists or it is not configured"));
}

QString ToolPathFinderPlugin::slotMameType()
{
QString execBin;
	switch (mameTypes->currentItem())
	{
		case 0: //SDL
			config->setGroup("general");
			execBin=config->readEntry("xmame_sdl","");
		break;

		case 1: //X11
			config->setGroup("general");
			execBin=config->readEntry("xmame_x11","");
		break;

		case 2: //XGL
			config->setGroup("general");
			execBin=config->readEntry("xmame_gl","");
		break;

		case 3: //SVGALIB
			config->setGroup("general");
			execBin=config->readEntry("xmame_svgalib","");
		break;
	}

	return execBin;
}
#include "toolpathfinder.moc"
